﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Komplett neu Labor2
using System.Windows.Media;

// Labor3
using System.Windows;

namespace CAD
{
    public class CADEllipse : CADParent
    {
        private int x, y, radiusX, radiusY;  // in mm
        private double strokeThickness;

        private DashStyle lineStyle;
        public Color brushFill;
        public Color brushLine;
        // private Color color;


        public int X
        {
            get { return x; }
            set { if (value > 0) x = value; }
        }
        public int Y
        {
            get { return y; }
            set { if (value > 0) y = value; }
        }
        public int RadiusX
        {
            get { return radiusX; }
            set { if (value > 0) radiusX = value; }
        }
        public int RadiusY
        {
            get { return radiusY; }
            set { if (value > 0) radiusY = value; }
        }
        public CADEllipse()
        {
            radiusX = 0;
            radiusY = 0;
            this.x = 0;
            this.y = 0;
            strokeThickness = 2;
            brushFill = Colors.Chartreuse;
            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_ELLIPSE;
        }

        public CADEllipse(CADEllipse elli)
        {
            radiusX = elli.radiusX;
            radiusY = elli.radiusY;
            this.x = elli.x;
            this.y = elli.y;
            strokeThickness = elli.strokeThickness;
            brushFill = elli.brushFill;
            lineStyle = elli.lineStyle;
            GraphicTyp = CADParent.GrfTypen.C_ELLIPSE;
        }

        public CADEllipse(int Mousex1, int Mousey1, int Mousex2, int Mousey2)
        {
            int x1, x2, y1, y2;
            if (Mousex1 < Mousex2)
            {
                x1 = Mousex1;
                x2 = Mousex2;
            }
            else
            {
                x1 = Mousex2;
                x2 = Mousex1;
            }

            if (Mousey1 < Mousey2)
            {
                y1 = Mousey1;
                y2 = Mousey2;
            }
            else
            {
                y1 = Mousey2;
                y2 = Mousey1;
            }

            radiusX = (int)Math.Round((x2 - x1) * 0.5);
            radiusY = (int)Math.Round((y2 - y1) * 0.5);

            this.x = (int)Math.Round((x1 + x2) * 0.5);
            this.y = (int)Math.Round((y1 + y2) * 0.5);
            strokeThickness = 2;
            brushFill = Colors.Chartreuse;
            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_ELLIPSE;
        }  // CADEllipse


        public double StrokeThickness
        {
            get { return strokeThickness; }
            set { if (strokeThickness > 0) strokeThickness = value; }
        }

        public DashStyle LineStyle
        {
            get { return lineStyle; }
            set { lineStyle = value; }
        }


        public override string ToString()
        {
            return "E: " + x + " / " + y + "   r:" + radiusX + " / " + radiusY;
        }


        public override void draw(DrawingContext dc, double zoom)
        {
            Pen pen;
            double dFactorMM = 94.5 / 25.4;  // Pixel pro mm
            double dF = dFactorMM * zoom;
            
            int gx = (int)Math.Round(X * dF);
            int gy = (int)Math.Round(Y * dF);
            int gradiusX = (int)Math.Round(RadiusX * dF);
            int gradiusY = (int)Math.Round(RadiusY * dF);

            double thick = StrokeThickness * zoom;
            if (thick <= 0.5) thick = 0.5;
            pen = new Pen(new SolidColorBrush(brushLine), thick);
            pen.DashStyle = LineStyle;

            dc.DrawEllipse(new SolidColorBrush(brushFill), pen, new Point(gx, gy), gradiusX, gradiusY);
        }
       
    }
}
