﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Komplett neu Labor2
using System.Windows.Media;

// Labor3
using System.Windows;


// Labor4
using System.Xml.Serialization;

namespace CAD
{

    public class CADLine : CADParent
    {

        private int x1, y1, x2, y2;
        private double strokeThickness;

        private DashStyle lineStyle;

        
        private Color brushLine;
        /*
         SolidColorBrush
         System.Windows.Media.GradientBrush
            LinearGradientBrush
            RadialGradientBrush 
         */

        public Color BrushLine
        {
            get { return brushLine; }
            set { 
                brushLine = value; 
            }
        }

        public DashStyle LineStyle
        {
            get { return lineStyle; }
            set { 
                lineStyle = value; 
            }
        }


        public int X1
        {
            get { return x1; }
            set
            {
                if (value > 0)
                {
                    x1 = value;
                }
               }
        }
        public int Y1
        {
            get { return y1; }
            set { if (value > 0) y1 = value; }
        }
        public int X2
        {
            get { return x2; }
            set { if (value > 0) x2 = value; }
        }
        public int Y2
        {
            get { return y2; }
            set { if (value > 0) y2 = value; }
        }

        public CADLine():this(0,0,0,0)
        {
        }

        public CADLine(int x1, int y1, int x2, int y2)
        {
            this.x1 = x1;
            this.y1 = y1;
            this.x2 = x2;
            this.y2 = y2;
            strokeThickness = 2;

            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_LINE;
            brushLine = Colors.Black;
        }

       

        public CADLine(CADLine line)
        {
            this.x1 = line.x1;
            this.y1 = line.y1;
            this.x2 = line.x2;
            this.y2 = line.y2;
            strokeThickness = line.strokeThickness;

            lineStyle = line.lineStyle;
            GraphicTyp = CADParent.GrfTypen.C_LINE;
            brushLine = line.brushLine;
        }

       
        public double StrokeThickness
        {
            get { return strokeThickness; }
            set { if (strokeThickness > 0.0) strokeThickness = value; }
        }

       
        public override string ToString()
        {
            return "L: " + x1 + " / " + y1 + "   " + x2 + " / " + y2;
        }

        public override void draw(DrawingContext dc, double zoom)
        {
            Pen pen;
            double dFactorMM = 94.5 / 25.4;  // Pixel pro mm
            double dF = dFactorMM * zoom;
            int gx1 = (int)Math.Round(x1 * dF);
            int gy1 = (int)Math.Round(y1 * dF);
            int gx2 = (int)Math.Round(x2 * dF);
            int gy2 = (int)Math.Round(y2 * dF);
            double thick = strokeThickness * zoom;
            if (thick <= 0.5) thick = 0.5;
            pen = new Pen(new SolidColorBrush(brushLine), thick);
            pen.DashStyle = lineStyle;  
            dc.DrawLine(pen, new Point(gx1, gy1), new Point(gx2, gy2));
        }

    }
}
