﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Media;
// Labor3
using System.Windows;

namespace CAD
{
    public class CADRectangle : CADParent
    {

        private int x1, y1, x2, y2;
        private double strokeThickness;

        private DashStyle lineStyle;
        public Color brushFill;
        public Color brushLine;


        public int X1
        {
            get { return x1; }
            set { if (value > 0) x1 = value; }
        }
        public int Y1
        {
            get { return y1; }
            set { if (value > 0) y1 = value; }
        }
        public int X2
        {
            get { return x2; }
            set { if (value > 0) x2 = value; }
        }
        public int Y2
        {
            get { return y2; }
            set { if (value > 0) y2 = value; }
        }

        public CADRectangle()
        {
            this.x1 = 0;
            this.y1 = 0;
            this.x2 = 0;
            this.y2 = 0;
            strokeThickness = 2;
            // color = Colors.Black;
            brushLine = Colors.Black;
            brushFill = Colors.Chartreuse;
            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_RECTANGLE;
        }

        public CADRectangle(CADRectangle rect)
        {
            this.x1 = rect.x1;
            this.y1 = rect.y1;
            this.x2 = rect.x2;
            this.y2 = rect.y2;
            strokeThickness = rect.strokeThickness;
            brushLine = rect.brushLine;
            brushFill = rect.brushFill;
            lineStyle = rect.lineStyle;
            GraphicTyp = CADParent.GrfTypen.C_RECTANGLE;
        }

        public CADRectangle(int Mousex1, int Mousey1, int Mousex2, int Mousey2)
        {
            if (Mousex1 < Mousex2)
            {
                x1 = Mousex1;
                x2 = Mousex2;
            }
            else
            {
                x1 = Mousex2;
                x2 = Mousex1;
            }

            if (Mousey1 < Mousey2)
            {
                y1 = Mousey1;
                y2 = Mousey2;
            }
            else
            {
                y1 = Mousey2;
                y2 = Mousey1;
            }
            strokeThickness = 2;
            // color = Colors.Black;
            brushLine = Colors.Black;
            brushFill = Colors.Chartreuse;
            lineStyle = DashStyles.Solid;
            GraphicTyp = CADParent.GrfTypen.C_RECTANGLE;
        }

        public double StrokeThickness
        {
            get { return strokeThickness; }
            set { if (strokeThickness > 0) strokeThickness = value; }
        }

        public DashStyle LineStyle
        {
            get { return lineStyle; }
            set { lineStyle = value; }
        }

        public override string ToString()
        {
            return "R: " + x1 + " / " + y1 + "   " + x2 + " / " + y2;
        }

        // Labor3
        public override void draw(DrawingContext dc, double zoom)
        {
            Pen pen;
            double dFactorMM = 94.5 / 25.4;  // Pixel pro mm
            double dF = dFactorMM * zoom;
            
            int gx1 = (int)Math.Round(x1 * dF);
            int gy1 = (int)Math.Round(y1 * dF);
            int gx2 = (int)Math.Round(x2 * dF);
            int gy2 = (int)Math.Round(y2 * dF);
            double thick = strokeThickness * zoom;
            if (thick <= 0.5) thick = 0.5;
            pen = new Pen(new SolidColorBrush(brushLine), thick);
            pen.DashStyle = lineStyle;
            Rect rect2 = new Rect(gx1, gy1, gx2 - gx1, gy2 - gy1);
            dc.DrawRectangle(new SolidColorBrush(brushFill), pen, rect2);
        }

    }
}
