﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

// neu
using System.Globalization;


namespace CAD
{
    /// <summary>
    /// Interaktionslogik für EditText.xaml
    /// </summary>
    public partial class EditText : Window
    {
        private  CADText _text;

        private bool bRetCode = false;
        // bool bStart = true;

        public bool Retcode
        {
            get { return bRetCode; }
        }

        public CADText Text
        {
            get { return _text; }
        }


        public EditText(CADText text)
        {
            InitializeComponent();
            _text = text;
            setGUI();
        }

        private void setGUI()
        {
            labelHelpAngle.Content = "0=waagerecht, -90=senkrecht:from Bottom to Top";
            tInputX.Text = _text.X.ToString();
            tInputY.Text = _text.Y.ToString();
            tInputText.Text = _text.Text;

            tInputAngle.Text = _text.Angle.ToString();
                                  
            textcolorCanvas.Background = new SolidColorBrush(_text.brushText);


            // tInputLinewidth.Text = _text.StrokeThickness.ToString("0.0", System.Globalization.CultureInfo.InvariantCulture);

        }

        private void bnOk_Click(object sender, RoutedEventArgs e)
        {
            int iValue = 0;            
            bool bcanConvert;
            bcanConvert = int.TryParse(tInputX.Text, out iValue);
            if (bcanConvert)
            {
                _text.X = iValue;
            }

            bcanConvert = int.TryParse(tInputY.Text, out iValue);
            if (bcanConvert)
            {
                _text.Y = iValue;
            }

            
            bcanConvert = int.TryParse(tInputAngle.Text, out iValue);
            if (bcanConvert)
            {
                _text.Angle = iValue;
            }

            _text.Text= tInputText.Text;


            bRetCode = true;
            Close();
        }

        private void bnCancel_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void bnColor_Click(object sender, RoutedEventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.setColor(_text.brushText);
            dialog.ShowDialog();
            if (dialog.Retcode)
            {
                _text.brushText = Color.FromArgb(dialog.Alpha, dialog.Red, dialog.Green, dialog.Blue);
                textcolorCanvas.Background = new SolidColorBrush(_text.brushText);
            }

        }

    }
}
