﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

// Komplett neu, Labor2

using System.IO;
using System.Xml;
using System.Xml.Serialization;

using System.Collections;
using System.Windows.Media;
using System.Windows.Controls;  // ArrayList


namespace CAD
{
    class Middleware
    {
        private static Middleware instance = new Middleware();

        private string sFilenameXml;

        public List<CADParent> cadListe = new List<CADParent>();

        public static Middleware getInstance()
        {
            return instance;
        }


        public string Filename
        {
            get { return sFilenameXml; }
            set { sFilenameXml = value; }
        }

        // Labor3
        public void deleteGraphic(int index)
        {
            int n = cadListe.Count;
            if ((n > 0) && (index < n))
            {
                cadListe.RemoveAt(index);
            }
        }

        // Labor3
        public void upGraphic(int index)
        {
            int n = cadListe.Count;
            if ((n > 0) && (index < n) && (index > 0))
            {
                CADParent grf = cadListe[index];
                cadListe.RemoveAt(index);
                cadListe.Insert(index - 1, grf);
            }
        }
        // Labor3
        public void downGraphic(int index)
        {
            int n = cadListe.Count;
            if ((n > 0) && (index < n) && (index < (n - 1)))
            {
                CADParent grf = cadListe[index];
                cadListe.RemoveAt(index);
                cadListe.Insert(index + 1, grf);
            }
        }


        // Labor3
        public void clearliste()
        {
            cadListe.Clear();
        }

        public void insertGraphicText(double zoom, double mouseX, double mouseY, double baseline, 
            string sText, Color brushLine, Color brushFill, ListBox graphicList)
        {
            double dFactorMM = 94.5 / 25.4;  // Pixel pro mm
            double f = dFactorMM * zoom;
            int x, y;
            x = (int)Math.Round(mouseX / f);
            y = (int)Math.Round(mouseY / f);                
            y = (int)Math.Round((mouseY - baseline) / f);

            CADText text;
            text = new CADText(x, y, sText);
            text.brushText = brushLine;
            cadListe.Add(text);
            graphicList.Items.Add(text);
        }


        // Labor4
        private int min(int a, int b)
        {
            if (a < b)
                return a;
            else
                return b;
        }

        // Labor4
        private int max(int a, int b)
        {
            if (a > b)
                return a;
            else
                return b;
        }

        // Labor4
        public void export2DXF(string sDXFFilename)
        {
            int minX = 0, maxX = 0, minY = 0, maxY = 0;
            for (int i = 0; i < cadListe.Count; i++)
            {
                CADParent grf = (CADParent)cadListe[i];
                switch (grf.GraphicTyp)
                {
                    case CADParent.GrfTypen.C_LINE:
                        CADLine line = (CADLine)grf;
                        if (i == 0)
                        {
                            minX = min(line.X1, line.X2);
                            maxX = max(line.X1, line.X2);
                            minY = min(line.Y1, line.Y2);
                            maxY = max(line.Y1, line.Y2);
                        }
                        else
                        {
                            minX = min(minX, line.X1);
                            maxX = max(maxX, line.X1);
                            minX = min(minX, line.X2);
                            maxX = max(maxX, line.X2);

                            minY = min(minY, line.Y1);
                            maxY = max(maxY, line.Y1);
                            minY = min(minY, line.Y2);
                            maxY = max(maxY, line.Y2);
                        }
                        break;

                    case CADParent.GrfTypen.C_RECTANGLE:
                        CADRectangle rect = (CADRectangle)grf;
                        if (i == 0)
                        {
                            minX = min(rect.X1, rect.X2);
                            maxX = max(rect.X1, rect.X2);
                            minY = min(rect.Y1, rect.Y2);
                            maxY = max(rect.Y1, rect.Y2);
                        }
                        else
                        {
                            minX = min(minX, rect.X1);
                            maxX = max(maxX, rect.X1);
                            minX = min(minX, rect.X2);
                            maxX = max(maxX, rect.X2);

                            minY = min(minY, rect.Y1);
                            maxY = max(maxY, rect.Y1);
                            minY = min(minY, rect.Y2);
                            maxY = max(maxY, rect.Y2);
                        }
                        break;

                    case CADParent.GrfTypen.C_CIRCLE:
                        CADCircle circle = (CADCircle)grf;
                        if (i == 0)
                        {
                            minX = circle.X - circle.Radius;
                            maxX = circle.X + circle.Radius;
                            minY = circle.Y - circle.Radius;
                            maxY = circle.Y + circle.Radius;
                        }
                        else
                        {
                            minX = min(minX, circle.X - circle.Radius);
                            maxX = max(maxX, circle.X + circle.Radius);

                            minY = min(minY, circle.Y - circle.Radius);
                            maxY = max(maxY, circle.Y + circle.Radius);
                        }
                        break;

                    case CADParent.GrfTypen.C_ELLIPSE:
                        CADEllipse ellipse = (CADEllipse)grf;
                        if (i == 0)
                        {
                            minX = ellipse.X - ellipse.RadiusX;
                            maxX = ellipse.X + ellipse.RadiusX;
                            minY = ellipse.Y - ellipse.RadiusY;
                            maxY = ellipse.Y + ellipse.RadiusY;
                        }
                        else
                        {
                            minX = min(minX, ellipse.X - ellipse.RadiusX);
                            maxX = max(maxX, ellipse.X + ellipse.RadiusX);

                            minY = min(minY, ellipse.Y - ellipse.RadiusY);
                            maxY = max(maxY, ellipse.Y + ellipse.RadiusY);
                        }
                        break;

                    case CADParent.GrfTypen.C_TEXT:
                        //CADText text = (CADText)grf;
                        //x = (int)Math.Round(text.X * dF);
                        //y = (int)Math.Round(text.Y * dF);
                        //formattedText = new FormattedText(text.Text,
                        //    CultureInfo.GetCultureInfo("en-us"),
                        //    FlowDirection.LeftToRight,
                        //    new Typeface("Verdana"),
                        //    32 * zoom, new SolidColorBrush(text.brushText));
                        //dc.DrawText(formattedText, new Point(x, y));
                        break;

                }  // switch

            }
            FileStream oFile = new FileStream(sDXFFilename, FileMode.Create);
            StreamWriter oStream = new StreamWriter(oFile);

            //oStream.WriteLine(value);
            oStream.WriteLine("  0");
            oStream.WriteLine("SECTION");
            oStream.WriteLine("  2");
            oStream.WriteLine("HEADER");
            oStream.WriteLine("  9");
            oStream.WriteLine("$EXTMAX");
            oStream.WriteLine(" 10");
            oStream.WriteLine(maxX.ToString());
            oStream.WriteLine(" 20");
            oStream.WriteLine(maxY.ToString());
            oStream.WriteLine("  9");
            oStream.WriteLine("$EXTMIN");
            oStream.WriteLine(" 10");
            oStream.WriteLine(minX.ToString());
            oStream.WriteLine(" 20");
            oStream.WriteLine(minY.ToString());
            oStream.WriteLine("  9");
            oStream.WriteLine("$LUPREC");
            oStream.WriteLine(" 70");
            oStream.WriteLine(" 14");
            oStream.WriteLine("  0");
            oStream.WriteLine("ENDSEC");

            // Create Tables Section
            oStream.WriteLine("  0");
            oStream.WriteLine("SECTION");
            oStream.WriteLine("  2");
            oStream.WriteLine("TABLES");
            oStream.WriteLine("  0");
            oStream.WriteLine("TABLE");
            oStream.WriteLine("  2");
            oStream.WriteLine("LAYER");
            oStream.WriteLine(" 70");
            oStream.WriteLine(" 49");
            oStream.WriteLine("  0");
            oStream.WriteLine("LAYER");
            oStream.WriteLine("  2");
            oStream.WriteLine("  0");
            oStream.WriteLine(" 70");
            oStream.WriteLine("  1");
            oStream.WriteLine(" 62");
            oStream.WriteLine("  7");
            oStream.WriteLine("  6");
            oStream.WriteLine("CONTINUOUS");

            // themenname
            oStream.WriteLine("  0");
            oStream.WriteLine("LAYER");
            oStream.WriteLine("  2");
            oStream.WriteLine("Layer1");
            oStream.WriteLine(" 70");
            oStream.WriteLine(" 64");
            oStream.WriteLine(" 62");
            oStream.WriteLine("  7");
            oStream.WriteLine("  6");
            oStream.WriteLine("CONTINUOUS");
            // end Layer loop

            oStream.WriteLine("  0");
            oStream.WriteLine("ENDTAB");
            oStream.WriteLine("  0");
            oStream.WriteLine("ENDSEC");

            // Create Blocks Section
            oStream.WriteLine("  0");
            oStream.WriteLine("SECTION");
            oStream.WriteLine("  2");
            oStream.WriteLine("BLOCKS");
            oStream.WriteLine("  0");
            oStream.WriteLine("ENDSEC");

            // Create Entities Section
            oStream.WriteLine("  0");
            oStream.WriteLine("SECTION");
            oStream.WriteLine("  2");
            oStream.WriteLine("ENTITIES");


            foreach (CADParent grf in cadListe)
            {
                switch (grf.GraphicTyp)
                {
                    case CADParent.GrfTypen.C_LINE:
                        CADLine line = (CADLine)grf;
                        oStream.WriteLine("  0");
                        oStream.WriteLine("POLYLINE");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("Attrib");
                        //oStream.WriteLine(" 62");
                        //oStream.WriteLine( 255 );  // theFeatureColor
                        oStream.WriteLine(" 66");
                        oStream.WriteLine("  1");

                        int[] x = new int[2];
                        int[] y = new int[2];
                        x[0] = line.X1; x[1] = line.X2;
                        y[0] = line.Y1; y[1] = line.Y2;
                        for (int i = 0; i < 2; i++)
                        {
                            oStream.WriteLine("  0");
                            oStream.WriteLine("VERTEX");
                            oStream.WriteLine("  8");
                            oStream.WriteLine("Linie");
                            oStream.WriteLine(" 10");
                            oStream.WriteLine(x[i]);
                            oStream.WriteLine(" 20");
                            oStream.WriteLine(y[i]);
                        }

                        oStream.WriteLine("  0");
                        oStream.WriteLine("SEQEND");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("0");
                        break;

                    case CADParent.GrfTypen.C_RECTANGLE:
                        CADRectangle rect = (CADRectangle)grf;
                        oStream.WriteLine("  0");
                        oStream.WriteLine("POLYLINE");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("Attrib");
                        //oStream.WriteLine(" 62");
                        //oStream.WriteLine( 255 );  // theFeatureColor
                        oStream.WriteLine(" 66");
                        oStream.WriteLine("  1");

                        int[] xR = new int[5];
                        int[] yR = new int[5];

                        xR[0] = rect.X1; xR[1] = rect.X2; xR[2] = rect.X2; xR[3] = rect.X1; xR[4] = rect.X1;
                        yR[0] = rect.Y1; yR[1] = rect.Y1; yR[2] = rect.Y2; yR[3] = rect.Y2; yR[4] = rect.Y1;

                        for (int i = 0; i < 5; i++)
                        {
                            oStream.WriteLine("  0");
                            oStream.WriteLine("VERTEX");
                            oStream.WriteLine("  8");
                            oStream.WriteLine("Linie");
                            oStream.WriteLine(" 10");
                            oStream.WriteLine(xR[i]);
                            oStream.WriteLine(" 20");
                            oStream.WriteLine(yR[i]);
                        }

                        oStream.WriteLine("  0");
                        oStream.WriteLine("SEQEND");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("0");
                        break;

                    case CADParent.GrfTypen.C_CIRCLE:
                        CADCircle circle = (CADCircle)grf;
                        oStream.WriteLine("  0");
                        oStream.WriteLine("POLYLINE");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("Attrib");
                        //oStream.WriteLine(" 62");
                        //oStream.WriteLine( 255 );  // theFeatureColor
                        oStream.WriteLine(" 66");
                        oStream.WriteLine("  1");

                        oStream.WriteLine("0");
                        oStream.WriteLine("CIRCLE");
                        oStream.WriteLine("8"); // Group code for layer name
                        oStream.WriteLine("0");   // Layer number
                        oStream.WriteLine("10"); // Code fuer Center point of circle
                        oStream.WriteLine(circle.X);  // X in OCS coordinates
                        oStream.WriteLine("20"); // Code fuer Center point of circle
                        oStream.WriteLine(circle.Y);  // Y in OCS coordinates
                        oStream.WriteLine("30"); // Code fuer Center point of circle
                        oStream.WriteLine("0");  // Z in OCS coordinates

                        oStream.WriteLine("40"); // Code fuer Center point of circle
                        oStream.WriteLine(circle.Radius);   // radius of circle	                    

                        oStream.WriteLine("  0");
                        oStream.WriteLine("SEQEND");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("0");
                        break;

                    case CADParent.GrfTypen.C_ELLIPSE:
                        CADEllipse ellipse = (CADEllipse)grf;
                        //oStream.WriteLine("  0");
                        //oStream.WriteLine("ELLIPSE");
                        //oStream.WriteLine("  8");
                        //oStream.WriteLine("Attrib");
                        ////oStream.WriteLine(" 62");
                        ////oStream.WriteLine( 255 );  // theFeatureColor
                        //oStream.WriteLine(" 66");
                        //oStream.WriteLine("  1");

                        oStream.WriteLine("0");
                        oStream.WriteLine("ELLIPSE");
                        oStream.WriteLine("5"); // 5 statt 8 Group code for layer name
                        oStream.WriteLine("1D");

                        oStream.WriteLine("100");
                        oStream.WriteLine("AcDbEntity"); // subClass

                        oStream.WriteLine("8"); // 5 statt 8 Group code for layer name
                        oStream.WriteLine("0");
                        oStream.WriteLine("100");
                        oStream.WriteLine("AcDbEntity"); // subClass

                        // oStream.WriteLine("0");   // Layer number
                        oStream.WriteLine("10"); // Code fuer Center point of circle
                        oStream.WriteLine(ellipse.X);  // X in OCS coordinates
                        oStream.WriteLine("20"); // Code fuer Center point of circle
                        oStream.WriteLine(ellipse.Y);  // Y in OCS coordinates
                        oStream.WriteLine("30"); // Code fuer Center point of circle
                        oStream.WriteLine("0");  // Z in OCS coordinates

                        oStream.WriteLine("11"); // Code fuer Center point of circle
                        oStream.WriteLine(ellipse.RadiusX);   // radius of circle
                        oStream.WriteLine("21");
                        oStream.WriteLine("0");
                        oStream.WriteLine("31");
                        oStream.WriteLine("0");

                        oStream.WriteLine("210");
                        oStream.WriteLine("0.0");
                        oStream.WriteLine("220");
                        oStream.WriteLine("0.0");
                        oStream.WriteLine("230");
                        oStream.WriteLine("1.0");

                        oStream.WriteLine("40"); // Code fuer Center point of circle
                        double d;
                        if (ellipse.RadiusX < ellipse.RadiusY)
                            d = (double)(1.0 * ellipse.RadiusX / ellipse.RadiusY);   // radius of circle
                        else
                            d = (double)(1.0 * ellipse.RadiusY / ellipse.RadiusX);   // radius of circle
                        string sd = d.ToString("##0.############", System.Globalization.CultureInfo.InvariantCulture);  // nun klappt es                        
                        oStream.WriteLine(sd);   // radius of circle
                        oStream.WriteLine("41");
                        oStream.WriteLine("0.0");

                        oStream.WriteLine("  0");
                        oStream.WriteLine("SEQEND");
                        oStream.WriteLine("  8");
                        oStream.WriteLine("0");
                        break;

                    case CADParent.GrfTypen.C_TEXT:
                        //CADText text = (CADText)grf;
                        //x = (int)Math.Round(text.X * dF);
                        //y = (int)Math.Round(text.Y * dF);
                        //formattedText = new FormattedText(text.Text,
                        //    CultureInfo.GetCultureInfo("en-us"),
                        //    FlowDirection.LeftToRight,
                        //    new Typeface("Verdana"),
                        //    32 * zoom, new SolidColorBrush(text.brushText));
                        //dc.DrawText(formattedText, new Point(x, y));
                        break;

                }  // switch

            }

            // Finish the Entities Section
            oStream.WriteLine("0");
            oStream.WriteLine("ENDSEC");
            oStream.WriteLine("0");
            oStream.WriteLine("EOF");
            oStream.Close();
            oFile.Close();
        }  // Export 2 DXF


        // Labor4
        public void loadlisteXml(String sFilenameXml)
        {
            this.sFilenameXml = sFilenameXml;
            cadListe.Clear();
            TextReader tin = new StreamReader(sFilenameXml);
            XmlSerializer xin = new XmlSerializer(cadListe.GetType());
            cadListe = (List<CADParent>)xin.Deserialize(tin);
            tin.Close();
        }


        // Labor4
        public void savelisteXml(String sFilenameXml)
        {
            this.sFilenameXml = sFilenameXml;
            TextWriter tout = new StreamWriter(sFilenameXml);
            XmlSerializer xout = new XmlSerializer(cadListe.GetType());

            xout.Serialize(tout, cadListe);
            tout.Flush();
            tout.Close();
        }


    }
}
