﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


// neu
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows;

using System.Globalization; // CultureInfo
using System.Collections;  // ArrayList
using System.Windows.Input; // Cursor


using System.Windows.Media.Imaging;  // BitmapSource



namespace CAD
{
    public class MyCanvas : Control  // UIElement  Control ContentControl   ScrollViewer
    {
        private  int moveFirst = 0;

        private Point pStart;
        private Point pMove;
        // Labor3
        private IChangeParent parent;
        private double zoom = 1.0;

       
        public int MoveFirst
        {
            set { moveFirst = value; }
            get { return moveFirst; }
        }


        private CADParent.GrfTypen modus = CADParent.GrfTypen.C_NONE;

        public CADParent.GrfTypen Modus
        {
            set { modus = value; }
            get { return modus; }
        }


        // Labor3
        public MyCanvas(IChangeParent parent)
        {
            this.parent = parent;
            Width = 5000;
            Height = 5000;
            Cursor = Cursors.Cross;
            this.MouseMove += canvas1_MouseMove;
            this.MouseLeftButtonDown += canvas1_MouseLeftButtonDown;
            this.MouseLeftButtonUp += canvas1_MouseLeftButtonUp;
        }

        // Labor3
        void canvas1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            base.OnMouseLeftButtonDown(e);
            if (this.modus != CADParent.GrfTypen.C_NONE)
            {
                if (this.modus == CADParent.GrfTypen.C_TEXT)
                {
                    Point pEnd = e.GetPosition(this);
                    FormattedText formattedText;
                    formattedText = new FormattedText("Ag",
                         CultureInfo.GetCultureInfo("en-us"),
                         FlowDirection.LeftToRight,
                         new Typeface("Verdana"),
                         32 * zoom, new SolidColorBrush(Colors.Black));
                    double baseline = formattedText.Baseline;
                    parent.insertGraphicsText(zoom, pEnd.X, pEnd.Y, baseline);
                }
                else
                {
                    this.pStart = e.GetPosition(this);
                    this.MoveFirst = 1;
                }
            }
        }  // MouseDown



        private void canvas1_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {           
            if ((this.modus != CADParent.GrfTypen.C_NONE) && (this.MoveFirst > 0))
            {                
                Point pEnd = e.GetPosition(this);
                parent.insertGraphic(zoom, pStart.X, pStart.Y, pEnd.X, pEnd.Y);
                MoveFirst = 0;
                this.InvalidateVisual();  // startet onRender
            }
        } // canvas1_MouseLeftButtonUp


        // Labor3
        private void canvas1_MouseMove(object sender, MouseEventArgs e)
        {
            base.OnMouseMove(e);            
            this.pMove = e.GetPosition(this);
            parent.setCoordX(pMove.X);
            parent.setCoordY(pMove.X);
            if ((this.modus != CADParent.GrfTypen.C_NONE) && (this.MoveFirst > 0))
            {
                this.MoveFirst = 2;
                this.InvalidateVisual();  // startet onRender
            }
        }  // canvas1_MouseMove


        public double Zoom
        {
            get { return zoom; }
            set
            {
                if (zoom > 0)
                {
                    zoom = value;
                    this.InvalidateVisual();
                }
            }
        }


        protected override void OnRender(DrawingContext dc)
        {
            base.OnRender(dc);
            Pen pen2 = new Pen(Brushes.Black, 2);
            pen2.DashStyle = DashStyles.Dash;
            Rect rect22 = new Rect(0, 0, Width, Height);
            dc.DrawRectangle(Brushes.White, pen2, rect22);

            foreach (CADParent grf in Middleware.getInstance().cadListe)
            {
                grf.draw(dc, zoom);
            }


            if ((modus != CADParent.GrfTypen.C_NONE) && (MoveFirst > 0))
            {
                Pen penX = new Pen(Brushes.Black, 2);
                penX.DashStyle = DashStyles.Dash;

                switch (modus)
                {
                    case CADParent.GrfTypen.C_LINE: dc.DrawLine(penX, this.pStart, pMove);
                        break;
                    case CADParent.GrfTypen.C_RECTANGLE: Rect rectX1 = new Rect(pStart, pMove);
                        dc.DrawRectangle(null, penX, rectX1);
                        break;
                    case CADParent.GrfTypen.C_CIRCLE: Rect rectX2 = new Rect(pStart, pMove);
                        dc.DrawRectangle(null, penX, rectX2);
                        break;
                    case CADParent.GrfTypen.C_ELLIPSE: Rect rectX3 = new Rect(pStart, pMove);
                        dc.DrawRectangle(null, penX, rectX3);
                        break;
                    case CADParent.GrfTypen.C_HORILINE: pStart.Y = pMove.Y;
                        dc.DrawLine(penX, this.pStart, pMove);
                        break;
                    case CADParent.GrfTypen.C_VERTLINE: pStart.X = pMove.X;
                        dc.DrawLine(penX, this.pStart, pMove);
                        break;
                }

            }
        }

    }

}

