﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Input;

namespace CAD
{
    public static class MyCommands
    {
        private static RoutedUICommand newfile;
        private static RoutedUICommand openfile;
        private static RoutedUICommand savefile;
        private static RoutedUICommand export2DXFfile;

        private static RoutedUICommand copy;
        private static RoutedUICommand paste;
        private static RoutedUICommand delete;

        private static RoutedUICommand console;

        private static RoutedUICommand print;

        static MyCommands()
        {
            newfile = new RoutedUICommand("Neue Datei", "NewFile", typeof(MyCommands));
            newfile.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control));  // ModifierKeys.Alt |

            openfile = new RoutedUICommand("Datei öfnen", "OpenFile", typeof(MyCommands));
            openfile.InputGestures.Add(new KeyGesture(Key.O, ModifierKeys.Control));  // ModifierKeys.Alt |

            savefile = new RoutedUICommand("Datei speichern", "SaveFile", typeof(MyCommands));
            savefile.InputGestures.Add(new KeyGesture(Key.S,  ModifierKeys.Control));

            export2DXFfile = new RoutedUICommand("Export nach DXF", "Export2DXFFile", typeof(MyCommands));
            export2DXFfile.InputGestures.Add(new KeyGesture(Key.E, ModifierKeys.Control));
            // openfile.InputGestures.Add(new MouseGesture(MouseAction.LeftDoubleClick, ModifierKeys.Alt | ModifierKeys.Control));


            copy = new RoutedUICommand("Kopieren", "CopyElement", typeof(MyCommands));
            copy.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Control));  

            paste = new RoutedUICommand("Einfügen", "InsertElement", typeof(MyCommands));
            paste.InputGestures.Add(new KeyGesture(Key.V, ModifierKeys.Control));  

            delete = new RoutedUICommand("Element löschen", "DeleteElement", typeof(MyCommands));
            delete.InputGestures.Add(new KeyGesture(Key.X, ModifierKeys.Control));

            print = new RoutedUICommand("Elemente drucken", "PrintElememts", typeof(MyCommands));
            print.InputGestures.Add(new KeyGesture(Key.P, ModifierKeys.Control));

            console = new RoutedUICommand("Elemente durch Console eingeben", "Console", typeof(MyCommands));
            
        }


        public static RoutedUICommand Copy
        {
            get { return copy; }
        }
        public static RoutedUICommand Paste
        {
            get { return paste; }
        }
        public static RoutedUICommand Delete
        {
            get { return delete; }
        }


        public static RoutedUICommand Newfile
        {
            get { return newfile; }
        }

        public static RoutedUICommand Openfile
        {
            get { return openfile; }
        }

        public static RoutedUICommand Savefile
        {
            get { return savefile; }
        }

        public static RoutedUICommand Export2DXFfile
        {
            get { return export2DXFfile; }
        }

        public static RoutedUICommand PrintElements
        {
            get { return print; }
        }

        public static RoutedUICommand Console
        {
            get { return console; }
        }
    }

}
